{ eXtended Explorer Form
   Amedeo Lanza <amldc@tin.it>

  Demonstration for Delphi controls needs:

  TSplitter - a splitter control
   Cerny Robert <Robert.Cerny@neosys.xrs.si>

  TToolbar97 - an Office97-like toolbar
   Jordan Russell <jordanr7@aol.com>
  http://members.aol.com/jordanr7

  TDirTree - a Directory TreeView
   Markus Stephany <MirBir.St@T-Online.de>
  http://home.t-online.de/home/MirBir.St/

  TFileList - a File ListView component for Delphi 2
   Amedeo Lanza <amldc@tin.it>
  http://volftp.tin.it/IT/IT/COLLABORAZIONI/LANZA/index.htm

description:
 This is a File Explorer sample using the Explorer's family of Delphi VCLs.
 You will need the above units to be installed in order to build this sample.
 You may find all these components on Delphi Super Page at
 http://SunSITE.icm.edu.pl/delphi/.

usage:
 Install the required components into the Delphi palette and open the project.
 First of all you may jump to TXExplorer.FormCreate code and modify the columns'
 caption (default is in English, this example set italian texts).
 Then... run it and explore your file system !


copyright & license
 Free use and distribution for non commercial purposes. See documentation for
 license restrictions.

DISCLAIMER:
 I ASK NO FEE and I GIVE NO WARRANTY for this software, either expressed or
 implied. Use it AT YOUR OWN RISK.

suggestions, bug reports & comments to the author:
 Amedeo Lanza di Casalanza
 from: Torino, Italy
 mailto:amldc@tin.it
 http://volftp.tin.it/IT/IT/COLLABORAZIONI/LANZA/index.htm

WARNING FOR EMAIL ABUSE:
 *BORLAND DELPHI* related messages are WELCOME, any other use of the author's
 email address for unsolicited ADVERTISING is STRICTLY PROHIBITED.

Thanks to all who shared their knowledge ...and controls. Also thanks to
DSP and UNDU for their precious services.

history:
 10-aug-1997 V0.1 amldc@tin.it
 Just dropped some controls and played around...
}
unit XExplFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, SpeedBar, ComCtrls, StdCtrls, FileCtrl, Menus,
  TB97,Splitctl, DirTree,FileList;

type
  TXExplorer = class(TForm)
    PanelLeft: TPanel;
    PanelRight: TPanel;
    StatusBar1: TStatusBar;
    DirTree1: TDirTree;
    Dock971: TDock97;
    tbViewStyle: TToolbar97;
    BtnViewReport: TToolbarButton97;
    BtnViewList: TToolbarButton97;
    BtnViewSmallIcon: TToolbarButton97;
    BtnViewIcon: TToolbarButton97;
    Splitter1: TSplitter;
    cbDisplayDir: TCheckBox;
    PanelRightLabel: TPanel;
    LabelPanelRight: TLabel;
    Panel1: TPanel;
    LabelPanelLeft: TLabel;
    Toolbar971: TToolbar97;
    DriveComboBox: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    ToolbarSep971: TToolbarSep97;
    ToolbarSep972: TToolbarSep97;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Options1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    FileList1: TFileList;
    ViewColumns1: TMenuItem;
    ItemViewName: TMenuItem;
    ItemViewSize: TMenuItem;
    ItemViewType: TMenuItem;
    ItemViewModified: TMenuItem;
    ItemViewCreated: TMenuItem;
    ItemViewLastAccess: TMenuItem;
    ItemViewAttributes: TMenuItem;
    ItemViewDosName: TMenuItem;
    ItemViewPath: TMenuItem;
    SortColumn1: TMenuItem;
    ItemSortName: TMenuItem;
    ItemSortSize: TMenuItem;
    ItemSortType: TMenuItem;
    ItemSortModified: TMenuItem;
    ItemSortCreated: TMenuItem;
    ItemSortLastAccess: TMenuItem;
    ItemSortAttributes: TMenuItem;
    ItemSortDosName: TMenuItem;
    ItemSortPath: TMenuItem;
    procedure DriveComboBoxChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DirTree1Change(Sender: TObject; Node: TTreeNode);
    procedure BtnViewIconClick(Sender: TObject);
    procedure BtnViewSmallIconClick(Sender: TObject);
    procedure BtnViewListClick(Sender: TObject);
    procedure BtnViewReportClick(Sender: TObject);
    procedure cbDisplayDirClick(Sender: TObject);
    procedure FilterComboBox1Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ItemSortClick(Sender: TObject);
    procedure ItemViewClick(Sender: TObject);
    procedure SortColumn1Click(Sender: TObject);
  private
    { Private declarations }
    procedure UpdatePanelLabels;
  public
    { Public declarations }
  protected
    procedure Loaded; override;
  end;

var
  XExplorer: TXExplorer;
(*  FileList1 :TFileList; *)

implementation

uses about;

{$R *.DFM}

//
// Update labels of left and right panel
//
procedure TXExplorer.UpdatePanelLabels;
begin
  with FileList1 do
    LabelPanelRight.Caption := format('Contents of "%s ( %s )"',
                      [AnsiLowerCase(Directory),Mask]);
end;
// Selected new drive
procedure TXExplorer.DriveComboBoxChange(Sender: TObject);
begin
  DirTree1.Drive := DriveComboBox.Drive;
//  FileList1.Directory := DirTree1.Directory;
  UpdatePanelLabels;
end;
// directory changed on Dir Tree
procedure TXExplorer.DirTree1Change(Sender: TObject; Node: TTreeNode);
begin
  DriveCombobox.Drive := DirTree1.Drive;
  FileList1.Directory := DirTree1.Directory;
  UpdatePanelLabels;
end;
// Selected new file mask
procedure TXExplorer.FilterComboBox1Change(Sender: TObject);
begin
  FileList1.Mask := FilterComboBox1.Mask;
  UpdatePanelLabels;
end;

//
// this was used for TFileList development
// purposes, may be suppressed if not needed
//
procedure TXExplorer.FormCreate(Sender: TObject);
begin
(*
  // used for control development
  FileList1 := TFileList.Create(Self);
  with FileList1 do
  begin

    Parent    := PanelRight;
    Align     := alClient;
    ViewStyle := vsReport;
    DisplayDirectory := true;
    ViewColumns := [fiName,fiSize,fiType,fiModified,fiCreated,
                    fiLastAccess,fiDosName,fiAttributes{,fiPath}];
  end;
*)
inherited;
end;

// Sets up FileVie1 columns
//
// note that columns's caption and width will
// be affected only in runtime
//
procedure TXExplorer.Loaded;
begin
  with FileList1 do
  begin
    SetColCaption(fiName,'Nome');
    SetColCaption(fiSize,'Dimensioni');
    SetColCaption(fiType,'Tipo di file');
    SetColCaption(fiModified,'Modificato');
    SetColCaption(fiCreated,'Creato');
    SetColCaption(fiLastAccess,'Ultimo accesso');
    SetColCaption(fiAttributes,'Attributi');
    SetColCaption(fiDosName,'Nome Dos');
    SetColCaption(fiPath,'Cartella');
    SetColWidth (fiName,150);
  end;
end;

// Select View Style
procedure TXExplorer.BtnViewIconClick(Sender: TObject);
begin
  FileList1.ViewStyle := vsIcon;
end;
// Select View Style
procedure TXExplorer.BtnViewSmallIconClick(Sender: TObject);
begin
  FileList1.ViewStyle := vsSmallIcon;
end;
// Select View Style
procedure TXExplorer.BtnViewListClick(Sender: TObject);
begin
  FileList1.ViewStyle := vsList;
end;
// Select View Style
procedure TXExplorer.BtnViewReportClick(Sender: TObject);
begin
  FileList1.ViewStyle := vsReport;
end;
// Include/Exclude directory listing
procedure TXExplorer.cbDisplayDirClick(Sender: TObject);
begin
  FileList1.DisplayDirectory := cbDisplayDir.Checked;
end;
//
// this was used for TFileList development
// purposes, may be suppressed if not needed
//
procedure TXExplorer.FormDestroy(Sender: TObject);
begin
(*  FileList1.Free; *)
inherited;
end;

procedure TXExplorer.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

// enable/disable sort items
procedure TXExplorer.SortColumn1Click(Sender: TObject);
begin
  ItemSortName.Enabled       := ItemViewName.Checked;
  ItemSortSize.Enabled       := ItemViewSize.Checked;
  ItemSortType.Enabled       := ItemViewType.Checked;
  ItemSortModified.Enabled   := ItemViewModified.Checked;
  ItemSortCreated.Enabled    := ItemViewCreated.Checked;
  ItemSortLastAccess.Enabled := ItemViewLastAccess.Checked;
  ItemSortAttributes.Enabled := ItemViewAttributes.Checked;
  ItemSortDosName.Enabled    := ItemViewDosName.Checked;
  ItemSortPath.Enabled       := ItemViewPath.Checked;
end;

procedure TXExplorer.ItemSortClick(Sender: TObject);
begin
  ItemSortName.Checked := false;
  ItemSortSize.Checked := false;
  ItemSortType.Checked := false;
  ItemSortModified.Checked := false;
  ItemSortCreated.Checked := false;
  ItemSortLastAccess.Checked := false;
  ItemSortAttributes.Checked := false;
  ItemSortDosName.Checked := false;
  ItemSortPath.Checked := false;
  (Sender as TMenuItem).Checked := true;
  FileList1.SortColumn := TFileInfo(TMenuItem(Sender).Tag);
end;

procedure TXExplorer.ItemViewClick(Sender: TObject);
var
  NewColSet :TFileInfos;
begin
  with (Sender as TMenuItem) do Checked := not Checked;
  NewColSet := [];
  if ItemViewName.Checked       then NewColSet := NewColSet + [fiName];
  if ItemViewSize.Checked       then NewColSet := NewColSet + [fiSize];
  if ItemViewType.Checked       then NewColSet := NewColSet + [fiType];
  if ItemViewModified.Checked   then NewColSet := NewColSet + [fiModified];
  if ItemViewCreated.Checked    then NewColSet := NewColSet + [fiCreated];
  if ItemViewLastAccess.Checked then NewColSet := NewColSet + [fiLastAccess];
  if ItemViewAttributes.Checked then NewColSet := NewColSet + [fiAttributes];
  if ItemViewDosName.Checked    then NewColSet := NewColSet + [fiDosName];
  if ItemViewPath.Checked       then NewColSet := NewColSet + [fiPath];
  FileList1.ViewColumns := NewColSet;
end;


end.
